![BepInEx logo](https://avatars2.githubusercontent.com/u/39589027?s=256)

# BepInExPack for Sunkenland

This is [BepInEx 5.4.22](https://github.com/BepInEx/BepInEx) pack pre-configured for Sunkenland. It is maintained by Azumatt

BepInEx is a general-purpose framework for Unity modding.
BepInEx includes tools and libraries to

* load custom code (hereafter *plugins*) into the game on launch;
* patch in-game methods, classes and even entire assemblies without touching original game files;
* Configure plugins and log game to desired outputs like console or file;
* Manage plugin dependencies.

BepInEx is currently [one of the most popular modding tools for Unity on GitHub](https://github.com/topics/modding?o=desc&s=stars).

## This pack's contents

This pack is preconfigured and usable for Valheim modding.  
In particular, the changes from base BepInEx releases are:

* Added preconfigured `BepInEx.cfg` with console enabled, prevented closing, and HideManagerGameObject.
* Updated Doorstop configuration and BepInEx to allow to loading of unstripped DLLs without having to overwrite game DLLs.

## Installation (game, automated)

This is the recommended way to install BepInEx on the game.

1. Download and install [Thunderstore Mod Manager](https://www.overwolf.com/app/Thunderstore-Thunderstore_Mod_Manager) or [r2modman](https://valheim.thunderstore.io/package/ebkr/r2modman/)
2. Click **Install with Mod Manager** button on top of the page
3. Run the game via the mod manager

## Installation (server, automated)

There are some managed dedicated server that support simple and automatic BepInEx installation.  
Here is a list of known ones (list updated as more is known).  
*Note: Some of the links may be affiliate links*


## Installation (manual)

If you are installing this manually, do the following

1. Extract the archive into a folder. **Do not extract into the game folder.**
2. Move the contents of `BepInExPack_Sunkenland` folder into `<Steam Location>\steamapps\common\Sunkenland`.
3. Check that you have installed it correctly. 
    If done correctly, your folder will look as follows

    ![BepInEx, winhttp.dll, and doorstop_config.ini in Sunkenland folder.](https://i.imgur.com/b7O6ZEk.png)
4. Follow either Windows or Linux game running instructions below:

### Configuration (Windows)

No need to configure. Simply run the game. If everything is correct, you will see a console pop up.

### Configuration (Linux, game)

1. Make `start_game_bepinex.sh` executable with `chmod u+x start_game_bepinex.sh`.
2. In Steam, go to game's properties and set game's launch arguments to
    
	```
	./start_game_bepinex.sh %command%
	```
	
	Note to advanced users: You can change `./start_game_bepinex.sh` to full path to the script. This way you can install this pack entirely outside of game folder.
3. Run the game via Steam.

At this moment you will not see any clear indication if BepInEx works.
It is suggested to test by installing a simple plugin such as [MessageCenter from BepInEx.Utility](https://github.com/BepInEx/BepInEx.Utility).

### Configuration (Linux, server)

This guide assumes you have enough knowledge of working with Linux.  
If not, it is suggested you use server hosts that support it out of the box.

1. Make `start_server_bepinex.sh` executable with `chmod u+x start_server_bepinex.sh`.
2. Edit `start_server_bepinex.sh` to change the launch parameter like you would with Valheim's own launch script.
3. Run `start_server_bepinex.sh` to start the server.

If done correctly, you will see BepInEx bootstrap messages in the terminal.


## Checking BepInEx version and load status

If BepInEx was loaded successfully into the game, you should see BepInEx version info in top left corner of the new console window that launches alongside the game:
`Please note that the information you see in this window is mostly related to the game's own output until mods are installed. This includes game logs, warnings, and errors.`

![BepInEx version in top-left corner of console window](https://i.imgur.com/urazxBa.png)

You will also be able to see how many patcher plugins are loading from the `BepInEx/patchers` folder as well as how many plugins are loading from the `BepInEx/plugins` folder (found in red). Loading of BepInEx and mods is complete when you see the `Chainloader startup complete` message (found in green)

![BepInEx console information about mods loading and chainloader completion](https://i.imgur.com/crM3DU2.png)

## Useful links

* [BepInEx: writing basic plugin walkthrough](https://docs.bepinex.dev/articles/dev_guide/plugin_tutorial/index.html)
* [BepInEx: useful plugins for modding](https://docs.bepinex.dev/articles/dev_guide/dev_tools.html)
* [BepInEx: patching game methods at runtime](https://docs.bepinex.dev/articles/dev_guide/runtime_patching.html)

## Issues, questions, etc.

At this moment, you can use the following channels to ask for help

* [BepInEx Discord](https://discord.gg/MpFEDAg) -- **Only technical support for THIS PACKAGE. No support for plugins. Most likely your issue is caused by a game update that could make your mods (plugins) not function correctly. This can cause various issues not related to BepInEx. Please only join this discord if you are sure that your issue is related to the modding framework and not a recent game update or plugin update**

# Sunkenland Modding Discord
* [Sunkenland Modding](https://mee6.xyz/i/TBXOoQJ8gE)

# List of Author-Specific Discords
* [Azumatt](https://discord.gg/pdHgy6Bsng)

`Feel free to ask Azumatt to add your own if you are a mod author`